//---------------- hpma ----------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_level1 70
#property indicator_level2 30
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_color1 clrDarkGoldenrod
//----
extern int nobs     =1000,
           periodRSI=14;
ENUM_APPLIED_PRICE priceRSI=0;
extern double lambda=1;
//----
double hpf[],dat[],a[],b[],c[];
datetime time;
//--------------------------------------
int init()
{
//----
   if(nobs>Bars-1) nobs=Bars-1;
   SetIndexBuffer(0,hpf);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"hpma");
   ArrayResize(hpf,nobs);
   ArrayResize(dat,nobs);
   ArrayResize(a,nobs);
   ArrayResize(b,nobs);
   ArrayResize(c,nobs);
   return(0);
}
//--------------------------------------
int start()
{
//----
   double H1,H2,H3,H4,H5,HH1,HH2,HH3,HH4,HH5,HB,HC,Z,V;
   int i, bar, limit=0;
//----------------
   for (bar=0; bar<=limit; bar++)
   {
     H1=0;H2=0;H3=0;H4=0;H5=0;HH1=0;HH2=0;HH3=0;HH4=0;HH5=0;
     for(i=0;i<nobs;i++)
     {
        dat[i]=iRSI(NULL,0,periodRSI,priceRSI,bar+i);
     }
     V=dat[0];  
     a[0]=1.0+lambda;
     b[0]=-2.0*lambda;
     c[0]=lambda;
     for(i=1;i<nobs-2;i++)
     {
        a[i]=6.0*lambda+1.0;
        b[i]=-4.0*lambda;
        c[i]=lambda;
     }
     a[1]=5.0*lambda+1;
     a[nobs-1]=1.0+lambda;
     a[nobs-2]=5.0*lambda+1.0;
     b[nobs-2]=-2.0*lambda;
     b[nobs-1]=0.0;
     c[nobs-2]=0.0;
     c[nobs-1]=0.0;

//---- Forward ----
     for(i=0;i<nobs;i++)
     {
        Z=a[i]-H4*H1-HH5*HH2;
        HB=b[i];
        HH1=H1;
        H1=(HB-H4*H2)/Z;
        b[i]=H1;
        HC=c[i];
        HH2=H2;
        H2=HC/Z;
        c[i]=H2;
        a[i]=(dat[i]-HH3*HH5-H3*H4)/Z;
        HH3=H3;
        H3=a[i];
        H4=HB-H5*HH1;
        HH5=H5;
        H5=HC;
     }
   
//---- Backward ----
     H2=0;
     H1=a[nobs-1];
     hpf[nobs-1]=H1;
     for(i=nobs-2;i>=0;i--)
     {
        hpf[i]=a[i]-b[i]*H1-c[i]*H2;
        H2=H1;
        H1=hpf[i];
     }
   }
//----
  return(0);
}
//------------------------------------ hpma